
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TracksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tracks = await db.tracks.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        track_type: data.track_type
        ||
        null
            ,
            
        instrument: data.instrument
        ||
        null
            ,
            
        volume_db: data.volume_db
        ||
        null
            ,
            
        pan: data.pan
        ||
        null
            ,
            
        mute: data.mute
        ||
        false
        
            ,
            
        solo: data.solo
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await tracks.setSong( data.song || null, {
            transaction,
        });
        
        await tracks.setSource_asset( data.source_asset || null, {
            transaction,
        });
        
        await tracks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return tracks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const tracksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                track_type: item.track_type
            ||
            null
            ,
            
                instrument: item.instrument
            ||
            null
            ,
            
                volume_db: item.volume_db
            ||
            null
            ,
            
                pan: item.pan
            ||
            null
            ,
            
                mute: item.mute
            ||
            false
        
            ,
            
                solo: item.solo
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const tracks = await db.tracks.bulkCreate(tracksData, { transaction });

        // For each item created, replace relation files
        

        return tracks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const tracks = await db.tracks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.track_type !== undefined) updatePayload.track_type = data.track_type;
        
        
        if (data.instrument !== undefined) updatePayload.instrument = data.instrument;
        
        
        if (data.volume_db !== undefined) updatePayload.volume_db = data.volume_db;
        
        
        if (data.pan !== undefined) updatePayload.pan = data.pan;
        
        
        if (data.mute !== undefined) updatePayload.mute = data.mute;
        
        
        if (data.solo !== undefined) updatePayload.solo = data.solo;
        
        
        updatePayload.updatedById = currentUser.id;

        await tracks.update(updatePayload, {transaction});

        
        
        if (data.song !== undefined) {
            await tracks.setSong(
              
              data.song,
              
              { transaction }
            );
        }
        
        if (data.source_asset !== undefined) {
            await tracks.setSource_asset(
              
              data.source_asset,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await tracks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return tracks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tracks = await db.tracks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of tracks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of tracks) {
                await record.destroy({transaction});
            }
        });


        return tracks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const tracks = await db.tracks.findByPk(id, options);

        await tracks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await tracks.destroy({
            transaction
        });

        return tracks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const tracks = await db.tracks.findOne(
            { where },
            { transaction },
        );

        if (!tracks) {
            return tracks;
        }

        const output = tracks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.song = await tracks.getSong({
            transaction
        });
        
        
        output.source_asset = await tracks.getSource_asset({
            transaction
        });
        
        
        output.organizations = await tracks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.songs,
        as: 'song',
        
        where: filter.song ? {
          [Op.or]: [
            { id: { [Op.in]: filter.song.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.song.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.assets,
        as: 'source_asset',
        
        where: filter.source_asset ? {
          [Op.or]: [
            { id: { [Op.in]: filter.source_asset.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.source_asset.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tracks',
                        'name',
                        filter.name,
                    ),
                };
            }
            

            
            

            
            if (filter.volume_dbRange) {
                const [start, end] = filter.volume_dbRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    volume_db: {
                    ...where.volume_db,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    volume_db: {
                    ...where.volume_db,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.panRange) {
                const [start, end] = filter.panRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    pan: {
                    ...where.pan,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    pan: {
                    ...where.pan,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.track_type) {
                where = {
                    ...where,
                track_type: filter.track_type,
            };
            }
            
            if (filter.instrument) {
                where = {
                    ...where,
                instrument: filter.instrument,
            };
            }
            
            if (filter.mute) {
                where = {
                    ...where,
                mute: filter.mute,
            };
            }
            
            if (filter.solo) {
                where = {
                    ...where,
                solo: filter.solo,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.tracks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'tracks',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.tracks.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

